﻿Imports System
Imports System.IO
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Data
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Navigation

Imports System.Windows.Media.Media3D

Partial Public Class Window1
    Public Sub New()
        MyBase.New()

        Me.InitializeComponent()

        ' Insert code required on object creation below this point.
    End Sub

    ' Build the squares.
    Private Sub Window_Loaded(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        Dim mat_yellow As New DiffuseMaterial(Brushes.Yellow)

        MakePlane(Model00, -1, -1, 1, 1, 0.1, 0.1, mat_yellow)
        MakePlane(Model10, -1, -1, 1, 1, 0.1, 0.1, mat_yellow)
        MakePlane(Model01, -1, -1, 1, 1, 0.1, 0.1, mat_yellow)
        MakePlane(Model11, -1, -1, 1, 1, 0.1, 0.1, mat_yellow)
    End Sub

    ' Make a plane.
    Private Sub MakePlane(ByVal model_group As Model3DGroup, ByVal xmin As Double, ByVal zmin As Double, ByVal xmax As Double, ByVal zmax As Double, ByVal dx As Double, ByVal dz As Double, ByVal plane_material As Material)
        Dim new_mesh As New MeshGeometry3D()
        new_mesh.Positions = New Point3DCollection()
        new_mesh.TriangleIndices = New Int32Collection()

        ' Make the points.
        Dim num_x As Integer = (xmax - xmin) / dx
        Dim num_z As Integer = (zmax - zmin) / dz
        Dim z As Double = zmin
        For iz As Integer = 1 To num_z
            Dim x As Double = xmin
            For ix As Integer = 1 To num_x
                new_mesh.Positions.Add(New Point3D(x, 0, z))
                x += dx
            Next ix
            z += dz
        Next iz

        ' Make the triangles.
        For iz As Integer = 0 To num_z - 2
            For ix As Integer = 0 To num_x - 2
                new_mesh.TriangleIndices.Add(iz * num_x + ix)
                new_mesh.TriangleIndices.Add((iz + 1) * num_x + ix)
                new_mesh.TriangleIndices.Add((iz + 1) * num_x + ix + 1)

                new_mesh.TriangleIndices.Add(iz * num_x + ix)
                new_mesh.TriangleIndices.Add((iz + 1) * num_x + ix + 1)
                new_mesh.TriangleIndices.Add(iz * num_x + ix + 1)
            Next ix
        Next iz

        ' Set the model's material.
        Dim new_model As New GeometryModel3D(new_mesh, plane_material)

        ' Add the new model to the model group.
        model_group.Children.Add(new_model)
    End Sub
End Class
